'-------------------------------------------------------------------------------------------
'  LCSoleil V1.0 Script
'
'  Un petit script pour calculer le lever du soleil, le coucher du soleil et a dure du jour 
'  avec +/-2min de prcision
'  suivant des coordonnes de Longitude et de Latitude gographique en France
'  Le script tient compte du changement de l'heure d't et d'hivers.
'  Le calcul se fait sur le jour de l'excution du script mais peut tre facilement adaptable
'
'  Contactinfo: psylog@psylog.com
'-------------------------------------------------------------------------------------------

Dim k, jm, jl, e, ob, PI
	PI = 3.1415926536
	k = 0.0172024
	jm = 308.67
	jl = 21.55
	e = 0.0167
	ob = 0.4091

Function GetTimeUTC()
	Dim DTMars, DTOctobre, txt
	txt=1
	For i=25 to 31
		if WeekdayName(weekday(I & "/03/" & right(date,2)))="dimanche" then
			DTMars = I & "/03/" & right(date,2)
		end if
	Next
	
	For i=25 to 31
		if WeekdayName(weekday(I & "/10/" & right(date,2)))="dimanche" then
			DTOctobre = (I-1) & "/10/" & right(date,2)
		end if
	Next
	if DateDiff("d",DTMars,Date)>=0 and DateDiff("d",Date,DTOctobre)>=0 then
		Txt=2
	End if
	GetTimeUTC = TXT
End Function




' Hauteur du soleil au lever et au coucher



Function CalculSol(Lon, Lat)
	Mo = Mid(Date,4,2)	'Mois
	Jo = Left(Date,2)	'Jour
	dr = PI / 180
	hr = PI / 12
	ht = -50 / 60
	ht = ht * dr

' Fuseau horaire et coordonnes gographiques
	fh = GetTimeUTC		'Calcul du decalage horaire
	La = Lat		'Lat
	Lo = Lon		'Lon
	La = La * dr
	Lo = Lo * dr

' Date
	If Mo < 3 Then Mo = Mo + 12

' Heure TU du milieu de la journe
	h = 12 + (Lo / hr)

' Nombre de jours couls depuis le 1 Mars O h TU
	J = Int(30.61 * (Mo + 1)) + Jo + (h / 24) - 123

' Anomalie et longitude moyenne
	M = k * (J - jm)
	L = k * (J - jl)

' Longitude vraie
	S = L + 2 * e * Sin(M) + 1.25 * e * e * Sin(2 * M)

' Coordonnes rectangulaires du soleil dans le repre quatorial
	X = Cos(S)
	Y = Cos(ob) * Sin(S)
	Z = Sin(ob) * Sin(S)

' Equation du temps et dclinaison
	R = L
	rx = Cos(R) * X + Sin(R) * Y
	ry = -Sin(R) * X + Cos(R) * Y
	X = rx
	Y = ry
	ET = Atn(Y / X)
	DC = Atn(Z / Sqr(1 - Z * Z))

' Angle horaire au lever et au coucher
	cs = (Sin(ht) - Sin(La) * Sin(DC)) / Cos(La) / Cos(DC)
	If cs > 1 Then 
		CalculSol = "Ne se lve pas"
		Exit Function
	End If
	If cs < -1 Then 
		CalculSol = "Ne se couche pas"
		Exit Function
	End IF
	If cs = 0 Then ah = PI / 2 Else ah = Atn(Sqr(1 - cs * cs) / cs)
	If cs < 0 Then ah = ah + PI

' Lever du soleil 
	Pm = h + fh + (ET - ah) / hr

	If Pm < 0 Then Pm = Pm + 24
	If Pm > 24 Then Pm = Pm - 24
	hs = Int(Pm)
	Pm = 60 * (Pm - hs)
	If int(Pm) = 60 Then 
		Pm = Pm - 60
		hs = hs + 1
	End if
	lev = hs & ":" & int(Pm)

' Memorisation des valeurs pour le calcul de la dure
	hsd=hs
	pmd=int(Pm)

' Coucher du soleil 
	Pm = h + fh + (ET + ah) / hr

	If Pm > 24 Then Pm = Pm - 24
	If Pm < 0 Then Pm = Pm + 24

	hs = Int(Pm)
	Pm = 60 * (Pm - hs)
	If int(Pm) = 60 Then 
		Pm = Pm - 60
		hs = hs + 1
	End if

	couch = hs & ":" & int(Pm)

'Memorisation des valeurs pour le calcul de la dure
	Pm=int(Pm)

	CalculSol = "Lever = " & lev & " , " & "Coucher = " & couch & " , " & "Dure : " & (hs-hsd) & ":" & abs(Pm -PMd)

End Function 